package data.hullmods;

import com.fs.starfarer.api.combat.BaseHullMod;
import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.combat.ShipAPI.HullSize;
import com.fs.starfarer.api.impl.campaign.ids.Stats;

public class dara_OverclockedNF extends BaseHullMod {

	public static final float RATE_DECREASE = 100f;		// Increase the rate at which Replacement Rate decays by 100%
	public static final float REFIT_BUFF = 40f;		// Reduce fighter refit time by 40%
	
	public static final float SUPPLIES_PER_DECK = 2f;	// Consume 2 supplies/month extra per bay
	
	
	public void applyEffectsBeforeShipCreation(HullSize hullSize, MutableShipStatsAPI stats, String id) {
		stats.getDynamic().getStat(Stats.REPLACEMENT_RATE_DECREASE_MULT).modifyPercent(id, RATE_DECREASE);
		stats.getFighterRefitTimeMult().modifyPercent(id, -REFIT_BUFF);
		
		int UPKEEP_INCREASE = (int) (stats.getNumFighterBays().getBaseValue() * SUPPLIES_PER_DECK);
		stats.getSuppliesPerMonth().modifyFlat(id, UPKEEP_INCREASE);
	}
		
	public String getDescriptionParam(int index, HullSize hullSize) {
		if (index == 0) return "" + (int) REFIT_BUFF + "%";
		//if (index == 1) return "" + (int) RATE_DECREASE + "%";
		if (index == 1) return "doubles";
		if (index == 2) return "" + (int) SUPPLIES_PER_DECK + "";
		if (index == 3) return "per fighter bay";
		return null;
	}
	
	public boolean isApplicableToShip(ShipAPI ship) {
		int bays = (int) ship.getMutableStats().getNumFighterBays().getBaseValue();
//		if (ship != null && ship.getVariant().getHullSpec().getBuiltInWings().size() >= bays) {
//			return false;
//		}
		return ship != null && bays > 0; 
	}
	
	public String getUnapplicableReason(ShipAPI ship) {
		return "Ship does not have standard fighter bays";
	}
}




